#include <stdio.h>
#include <omp.h>

int
main(void)
{
    volatile uint64_t token = 0;

    #pragma omp parallel default(none) shared(token)
    {
        int id = omp_get_thread_num();

        while (token != id)
            ; // active waiting

        printf("[%lu]\tI have the token!\n", frame->id);

        #pragma omp atomic
        token += 1;
    }

    return 0;
}
